diff --git a/src/main/java/net/minecraft/client/render/CameraSorter.java b/src/main/java/net/minecraft/client/render/CameraSorter.java
index 2d3a60845..1a4c4a725 100644
--- a/src/main/java/net/minecraft/client/render/CameraSorter.java
+++ b/src/main/java/net/minecraft/client/render/CameraSorter.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render;
 
-import net.minecraft.client.render.ChunkRenderer;
 import net.minecraft.client.render.camera.ICamera;
 
 import java.util.Comparator;
@@ -21,12 +20,12 @@ public class CameraSorter
 
     public int sortByDistanceToEntity(ChunkRenderer a, ChunkRenderer b)
     {
-        double dx1 = (double)a.posXPlus + posX;
-        double dy1 = (double)a.posYPlus + posY;
-        double dz1 = (double)a.posZPlus + posZ;
-        double dx2 = (double)b.posXPlus + posX;
-        double dy2 = (double)b.posYPlus + posY;
-        double dz2 = (double)b.posZPlus + posZ;
+        double dx1 = (double)a.xm + posX;
+        double dy1 = (double)a.ym + posY;
+        double dz1 = (double)a.zm + posZ;
+        double dx2 = (double)b.xm + posX;
+        double dy2 = (double)b.ym + posY;
+        double dz2 = (double)b.zm + posZ;
         return (int)(((dx1 * dx1 + dy1 * dy1 + dz1 * dz1) - (dx2 * dx2 + dy2 * dy2 + dz2 * dz2)) * 1024D);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/ChunkRenderer.java b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
index 10fc0cc9a..80f657931 100644
--- a/src/main/java/net/minecraft/client/render/ChunkRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
@@ -7,7 +7,7 @@ import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.entity.ItemEntityRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
@@ -25,71 +25,104 @@ public class ChunkRenderer
 {
     public static final int MAX_RENDER_PASSES = 2;
 
-    public ChunkRenderer(RenderEngine renderEngine, World world, List<TileEntity> list, int posX, int posY, int posZ, int size, int renderList)
+    public World world;
+    private final int lists;
+    private static final Tessellator tessellator;
+    public static int updates = 0;
+    public int x;
+    public int y;
+    public int z;
+    public int xs;
+    public int ys;
+    public int zs;
+    public int xRender;
+    public int yRender;
+    public int zRender;
+    public int xRenderOffs;
+    public int yRenderOffs;
+    public int zRenderOffs;
+    public boolean visible;
+    public boolean[] empty;
+    public int xm;
+    public int ym;
+    public int zm;
+    public float radius;
+    public boolean dirty;
+    public AABB bb;
+    public int id;
+    public boolean occlusionVisible;
+    public boolean occlusionQuerying;
+    public int occlusionId;
+    public boolean skyLit;
+    private boolean compiled;
+    public List<BlockEntity> renderableBlockEntities;
+    private final List<BlockEntity> globalRenderableBlockEntities;
+
+    public ChunkRenderer(World world, List<BlockEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists)
     {
-        isInFrustum = false;
-        skipRenderPass = new boolean[MAX_RENDER_PASSES];
-        isVisible = true;
-        isInitialized = false;
-        specialTileEntities = new ArrayList<>();
-        worldObj = world;
-        tileEntities = list;
-        sizeWidth = sizeHeight = sizeDepth = size;
-        rendererRadius = MathHelper.sqrt_float(sizeWidth * sizeWidth + sizeHeight * sizeHeight + sizeDepth * sizeDepth) / 2.0F;
-        glRenderList = renderList;
-        this.posX = -999;
-        setPosition(posX, posY, posZ);
-        needsUpdate = false;
+        visible = false;
+        empty = new boolean[MAX_RENDER_PASSES];
+        occlusionVisible = true;
+        compiled = false;
+        renderableBlockEntities = new ArrayList<>();
+        this.world = world;
+        globalRenderableBlockEntities = globalRenderableTileEntities;
+        xs = ys = zs = size;
+        radius = MathHelper.sqrt_float(xs * xs + ys * ys + zs * zs) / 2.0F;
+        this.lists = lists;
+        this.x = -999;
+        setPos(x, y, z);
+        dirty = false;
     }
 
-    public void setPosition(int x, int y, int z)
+    public void setPos(int x, int y, int z)
     {
-        if (x != posX || y != posY || z != posZ)
+        if (x != this.x || y != this.y || z != this.z)
         {
-            setDontDraw();
-            posX = x;
-            posY = y;
-            posZ = z;
-            posXPlus = x + sizeWidth / 2;
-            posYPlus = y + sizeHeight / 2;
-            posZPlus = z + sizeDepth / 2;
-            posXClip = x & 0x3ff;
-            posYClip = y;
-            posZClip = z & 0x3ff;
-            posXMinus = x - posXClip;
-            posYMinus = y - posYClip;
-            posZMinus = z - posZClip;
+            reset();
+            this.x = x;
+            this.y = y;
+            this.z = z;
+            xm = x + xs / 2;
+            ym = y + ys / 2;
+            zm = z + zs / 2;
+            xRenderOffs = x & 0x3ff;
+            yRenderOffs = y;
+            zRenderOffs = z & 0x3ff;
+            xRender = x - xRenderOffs;
+            yRender = y - yRenderOffs;
+            zRender = z - zRenderOffs;
             float f = 6F;
-            rendererBoundingBox = AABB.getBoundingBox((float)x - f, (float)y - f, (float)z - f, (float)(x + sizeWidth) + f, (float)(y + sizeHeight) + f, (float)(z + sizeDepth) + f);
-            GL11.glNewList(glRenderList + MAX_RENDER_PASSES, GL11.GL_COMPILE);
-            ItemEntityRenderer.renderAABB(AABB.getBoundingBoxFromPool((float)posXClip - f, (float)posYClip - f, (float)posZClip - f, (float)(posXClip + sizeWidth) + f, (float)(posYClip + sizeHeight) + f, (float)(posZClip + sizeDepth) + f));
+            bb = AABB.getPermanentBB((float)x - f, (float)y - f, (float)z - f, (float)(x + xs) + f, (float)(y + ys) + f, (float)(z + zs) + f);
+            GL11.glNewList(lists + MAX_RENDER_PASSES, GL11.GL_COMPILE);
+            ItemEntityRenderer.renderFlatAABB(AABB.getTemporaryBB((float) xRenderOffs - f, (float) yRenderOffs - f, (float) zRenderOffs - f, (float)(xRenderOffs + xs) + f, (float)(yRenderOffs + ys) + f, (float)(zRenderOffs + zs) + f));
             GL11.glEndList();
-            markDirty();
+            setDirty();
         }
     }
 
-    private void setupGLTranslation()
+    private void translateToPos()
     {
-        GL11.glTranslatef(posXClip, posYClip, posZClip);
+        GL11.glTranslatef(xRenderOffs, yRenderOffs, zRenderOffs);
     }
 
-    public void updateRenderer()
+    public void rebuild()
     {
-        if(!needsUpdate) { return; }
-        chunksUpdated++;
-        final int minX = posX;
-        final int minY = posY;
-        final int minZ = posZ;
-        final int maxX = posX + sizeWidth;
-        final int maxY = posY + sizeHeight;
-        final int maxZ = posZ + sizeDepth;
-        for(int i = 0; i < MAX_RENDER_PASSES; i++) { skipRenderPass[i] = true; }
+        if(!dirty) { return; }
+        updates++;
+        final int minX = x;
+        final int minY = y;
+        final int minZ = z;
+        final int maxX = x + xs;
+        final int maxY = y + ys;
+        final int maxZ = z + zs;
+        for(int i = 0; i < MAX_RENDER_PASSES; i++) { empty[i] = true; }
 
         Chunk.isLit = false;
-        final Set<TileEntity> lastSpecialTileEntities = new HashSet<>(specialTileEntities);
-        specialTileEntities.clear();
+        final Set<BlockEntity> lastSpecialTileEntities = new HashSet<>(renderableBlockEntities);
+        renderableBlockEntities.clear();
         final int cacheRadius = 1;
-        final ChunkCache chunkcache = new ChunkCache(worldObj, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
+        final ChunkCache chunkcache = new ChunkCache(world, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
         final RenderBlocks renderblocks = new RenderBlocks(chunkcache);
         BlockModel.setRenderBlocks(renderblocks);
         int renderPass = 0;
@@ -113,15 +146,15 @@ public class ChunkRenderer
                         }
                         if(!hasStartedDrawing) {
                             hasStartedDrawing = true;
-                            GL11.glNewList(glRenderList + renderPass, GL11.GL_COMPILE);
+                            GL11.glNewList(lists + renderPass, GL11.GL_COMPILE);
                             GL11.glPushMatrix();
-                            setupGLTranslation();
+                            translateToPos();
                             final float scale = 1.000001F;
-                            GL11.glTranslatef((float)(-sizeDepth) / 2.0F, (float)(-sizeHeight) / 2.0F, (float)(-sizeDepth) / 2.0F);
+                            GL11.glTranslatef((float)(-zs) / 2.0F, (float)(-ys) / 2.0F, (float)(-zs) / 2.0F);
                             GL11.glScalef(scale, scale, scale);
-                            GL11.glTranslatef((float)sizeDepth / 2.0F, (float)sizeHeight / 2.0F, (float)sizeDepth / 2.0F);
+                            GL11.glTranslatef((float) zs / 2.0F, (float) ys / 2.0F, (float) zs / 2.0F);
                             tessellator.startDrawingQuads();
-                            tessellator.setTranslation(-posX, -posY, -posZ);
+                            tessellator.setTranslation(-this.x, -this.y, -this.z);
                             
                             if(LightmapHelper.isLightmapEnabled()) {
                             	// Make sure it's active
@@ -129,20 +162,20 @@ public class ChunkRenderer
                             }
                         }
                         if(renderPass == 0 && Block.isEntityTile[blockId]) {
-                            final TileEntity tileentity = chunkcache.getBlockTileEntity(x, y, z);
-                            if(TileEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
-                                specialTileEntities.add(tileentity);
+                            final BlockEntity tileentity = chunkcache.getBlockEntity(x, y, z);
+                            if(BlockEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
+                                renderableBlockEntities.add(tileentity);
                             }
                         }
                         final Block block = Block.blocksList[blockId];
-                        final int blockRenderPass = block.getRenderBlockPass();
+                        final int blockRenderPass = block.getRenderLayer();
                         if(blockRenderPass != renderPass) {
                             needsMoreRenderPasses = true;
                         }
                         else {
                         	if(LightmapHelper.isLightmapEnabled()) {
                         		// Can probably be removed once all block models support the lightmap
-                        		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));	
+                        		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
                         	}
                             
                             final BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
@@ -166,7 +199,7 @@ public class ChunkRenderer
             }
             
             if(hasRenderedBlock) {
-                skipRenderPass[renderPass] = false;
+                empty[renderPass] = false;
             }            
             if(!needsMoreRenderPasses) {
                 break;
@@ -174,57 +207,57 @@ public class ChunkRenderer
             
             renderPass++;
         } while(true);
-        HashSet<TileEntity> newSpecialTileEntities = new HashSet<>(specialTileEntities);
+        HashSet<BlockEntity> newSpecialTileEntities = new HashSet<>(renderableBlockEntities);
         newSpecialTileEntities.removeAll(lastSpecialTileEntities);
-        tileEntities.addAll(newSpecialTileEntities);
-        specialTileEntities.forEach(lastSpecialTileEntities::remove);
-        tileEntities.removeAll(lastSpecialTileEntities);
-        isChunkLit = Chunk.isLit;
-        isInitialized = true;
+        globalRenderableBlockEntities.addAll(newSpecialTileEntities);
+        renderableBlockEntities.forEach(lastSpecialTileEntities::remove);
+        globalRenderableBlockEntities.removeAll(lastSpecialTileEntities);
+        skyLit = Chunk.isLit;
+        compiled = true;
     }
 
     public float distanceToEntitySquared(Entity entity)
     {
-        float dx = (float)(entity.x - (double)posXPlus);
-        float dy = (float)(entity.y - (double)posYPlus);
-        float dz = (float)(entity.z - (double)posZPlus);
+        float dx = (float)(entity.x - (double) xm);
+        float dy = (float)(entity.y - (double) ym);
+        float dz = (float)(entity.z - (double) zm);
         return dx * dx + dy * dy + dz * dz;
     }
 
     public float distanceToCameraSquared(ICamera camera)
     {
-        float dx = (float)(camera.getX(1f) - posXPlus);
-        float dy = (float)(camera.getY(1f) - posYPlus);
-        float dz = (float)(camera.getZ(1f) - posZPlus);
+        float dx = (float)(camera.getX(1f) - xm);
+        float dy = (float)(camera.getY(1f) - ym);
+        float dz = (float)(camera.getZ(1f) - zm);
         return dx * dx + dy * dy + dz * dz;
     }
 
-    public void setDontDraw()
+    public void reset()
     {
         for(int i = 0; i < MAX_RENDER_PASSES; i++)
         {
-            skipRenderPass[i] = true;
+            empty[i] = true;
         }
 
-        isInFrustum = false;
-        isInitialized = false;
+        visible = false;
+        compiled = false;
     }
 
-    public void reset()
+    public void delete()
     {
-        setDontDraw();
-        worldObj = null;
+        reset();
+        world = null;
     }
 
-    public int getGLCallListForPass(int i)
+    public int getList(int layer)
     {
-        if(!isInFrustum)
+        if(!visible)
         {
             return -1;
         }
-        if(!skipRenderPass[i])
+        if(!empty[layer])
         {
-            return glRenderList + i;
+            return lists + layer;
         } 
         else
         {
@@ -232,65 +265,32 @@ public class ChunkRenderer
         }
     }
 
-    public void updateInFrustum(CameraFrustum frustum, float partialTick)
+    public void cull(CameraFrustum frustum, float partialTick)
     {
-        isInFrustum = frustum.isVisible(rendererBoundingBox, partialTick);
+        visible = frustum.isVisible(bb, partialTick);
     }
 
-    public void callOcclusionQueryList()
+    public void renderBB()
     {
-        GL11.glCallList(glRenderList + MAX_RENDER_PASSES);
+        GL11.glCallList(lists + MAX_RENDER_PASSES);
     }
 
-    public boolean skipAllRenderPasses()
+    public boolean isEmpty()
     {
-        if(!isInitialized)
+        if(!compiled)
         {
             return false;
         } else
         {
-            return skipRenderPass[0] && skipRenderPass[1];
+            return empty[0] && empty[1];
         }
     }
 
-    public void markDirty()
+    public void setDirty()
     {
-        needsUpdate = true;
+        dirty = true;
     }
 
-    public World worldObj;
-    private final int glRenderList;
-    private static final Tessellator tessellator;
-    public static int chunksUpdated = 0;
-    public int posX;
-    public int posY;
-    public int posZ;
-    public int sizeWidth;
-    public int sizeHeight;
-    public int sizeDepth;
-    public int posXMinus;
-    public int posYMinus;
-    public int posZMinus;
-    public int posXClip;
-    public int posYClip;
-    public int posZClip;
-    public boolean isInFrustum;
-    public boolean[] skipRenderPass;
-    public int posXPlus;
-    public int posYPlus;
-    public int posZPlus;
-    public float rendererRadius;
-    public boolean needsUpdate;
-    public AABB rendererBoundingBox;
-    public int chunkIndex;
-    public boolean isVisible;
-    public boolean isWaitingOnOcclusionQuery;
-    public int glOcclusionQuery;
-    public boolean isChunkLit;
-    private boolean isInitialized;
-    public List<TileEntity> specialTileEntities;
-    private final List<TileEntity> tileEntities;
-
     static 
     {
         tessellator = Tessellator.instance;
diff --git a/src/main/java/net/minecraft/client/render/ChunkRendererComparator.java b/src/main/java/net/minecraft/client/render/ChunkRendererComparator.java
index eb38caa4b..86185a0e9 100644
--- a/src/main/java/net/minecraft/client/render/ChunkRendererComparator.java
+++ b/src/main/java/net/minecraft/client/render/ChunkRendererComparator.java
@@ -5,7 +5,7 @@ import net.minecraft.client.render.camera.ICamera;
 import java.util.Comparator;
 
 // Referenced classes of package net.minecraft.src:
-//            WorldRenderer, EntityLiving
+//            WorldRenderer, Mob
 
 public class ChunkRendererComparator
     implements Comparator<ChunkRenderer>
@@ -19,8 +19,8 @@ public class ChunkRendererComparator
     @Override
     public int compare(ChunkRenderer cr1, ChunkRenderer cr2)
     {
-        boolean cr1InFrustum = cr1.isInFrustum;
-        boolean cr2InFrustum = cr2.isInFrustum;
+        boolean cr1InFrustum = cr1.visible;
+        boolean cr2InFrustum = cr2.visible;
         if (cr1.equals(cr2))
         {
             return 0;
@@ -45,7 +45,7 @@ public class ChunkRendererComparator
         }
         else
         {
-            return cr1.chunkIndex >= cr2.chunkIndex ? -1 : 1;
+            return cr1.id >= cr2.id ? -1 : 1;
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/EffectRenderer.java b/src/main/java/net/minecraft/client/render/EffectRenderer.java
index 527d5d8b7..d1b2c1e2c 100644
--- a/src/main/java/net/minecraft/client/render/EffectRenderer.java
+++ b/src/main/java/net/minecraft/client/render/EffectRenderer.java
@@ -3,14 +3,15 @@ package net.minecraft.client.render;
 import java.util.*;
 
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.entity.fx.EntityDiggingFX;
-import net.minecraft.client.entity.fx.EntityFX;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.entity.particle.TerrainParticle;
+import net.minecraft.client.entity.particle.Particle;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
@@ -36,9 +37,9 @@ public class EffectRenderer
 
     }
 
-    public void addEffect(EntityFX entityfx)
+    public void addEffect(Particle entityfx)
     {
-        int i = entityfx.getFXLayer();
+        int i = entityfx.getParticleTexture();
         if(fxLayers[i].size() >= 4000)
         {
             fxLayers[i].remove(0);
@@ -52,7 +53,7 @@ public class EffectRenderer
         {
             for(int j = 0; j < fxLayers[i].size(); j++)
             {
-                EntityFX entityfx = (EntityFX)fxLayers[i].get(j);
+                Particle entityfx = (Particle)fxLayers[i].get(j);
                 entityfx.tick();
                 if(entityfx.removed)
                 {
@@ -73,9 +74,9 @@ public class EffectRenderer
         float rotationYZ = -rotationZ * MathHelper.sin((float) ((pitch * Math.PI) / 180F));
         float rotationXY = rotationX * MathHelper.sin((float) ((pitch * Math.PI) / 180F));
         float rotationXZ = MathHelper.cos((float) ((pitch * Math.PI) / 180F));
-        EntityFX.lerpPosX = camera.getX(partialTick);
-        EntityFX.lerpPosY = camera.getY(partialTick);
-        EntityFX.lerpPosZ = camera.getZ(partialTick);
+        Particle.xOff = camera.getX(partialTick);
+        Particle.yOff = camera.getY(partialTick);
+        Particle.zOff = camera.getZ(partialTick);
 
         for(int i = 0; i < 3; i++)
         {
@@ -86,23 +87,23 @@ public class EffectRenderer
             int texture = 0;
             if(i == 0)
             {
-                texture = TextureRegistry.particleAtlas.getTextureId();
+                texture = TextureRegistry.particleAtlas.id();
             }
             if(i == 1)
             {
-                texture = TextureRegistry.blockAtlas.getTextureId();
+                texture = TextureRegistry.blockAtlas.id();
             }
             if(i == 2)
             {
-                texture = TextureRegistry.itemAtlas.getTextureId();
+                texture = TextureRegistry.itemAtlas.id();
             }
             GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture);
             Tessellator tessellator = Tessellator.instance;
             tessellator.startDrawingQuads();
             for(int k = 0; k < fxLayers[i].size(); k++)
             {
-                EntityFX entityfx = (EntityFX)fxLayers[i].get(k);
-                entityfx.renderParticle(tessellator, partialTick, rotationX, rotationXZ, rotationZ, rotationYZ, rotationXY);
+                Particle entityfx = (Particle)fxLayers[i].get(k);
+                entityfx.render(tessellator, partialTick, rotationX, rotationXZ, rotationZ, rotationYZ, rotationXY);
             }
 
             tessellator.draw();
@@ -119,8 +120,8 @@ public class EffectRenderer
         Tessellator tessellator = Tessellator.instance;
         for(int i = 0; i < fxLayers[layerId].size(); i++)
         {
-            EntityFX entityfx = (EntityFX)fxLayers[layerId].get(i);
-            entityfx.renderParticle(tessellator, partialTick, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F);
+            Particle entityfx = (Particle)fxLayers[layerId].get(i);
+            entityfx.render(tessellator, partialTick, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F);
         }
 
     }
@@ -140,7 +141,7 @@ public class EffectRenderer
         Block block = Block.blocksList[blockId];
         if (block == null) return;
         int amount = 4;
-        if(block == Block.fire)
+        if(block == Blocks.FIRE)
             return;
         for(int _x = 0; _x < amount; _x++)
         {
@@ -152,7 +153,7 @@ public class EffectRenderer
                     double pY = (double)y + ((double)_y + 0.5D) / (double)amount;
                     double pZ = (double)z + ((double)_z + 0.5D) / (double)amount;
                     int side = rand.nextInt(6);
-                    addEffect((new EntityDiggingFX(worldObj, pX, pY, pZ, pX - (double)x - 0.5D, pY - (double)y - 0.5D, pZ - (double)z - 0.5D, block, side, i1)).setParticleColor(x, y, z));
+                    addEffect((new TerrainParticle(worldObj, pX, pY, pZ, pX - (double)x - 0.5D, pY - (double)y - 0.5D, pZ - (double)z - 0.5D, block, side, i1)).init(x, y, z));
                 }
 
             }
@@ -198,7 +199,7 @@ public class EffectRenderer
         {
             d = (double)i + block.maxX + (double)f;
         }
-        addEffect((new EntityDiggingFX(worldObj, d, d1, d2, 0.0D, 0.0D, 0.0D, block, l, worldObj.getBlockMetadata(i, j, k))).setParticleColor(i, j, k).func_407_b(0.2F).func_405_d(0.6F));
+        addEffect((new TerrainParticle(worldObj, d, d1, d2, 0.0D, 0.0D, 0.0D, block, l, worldObj.getBlockMetadata(i, j, k))).init(i, j, k).setPower(0.2F).setScale(0.6F));
     }
 
     public String getNumParticlesString()
